"""
Copyright (c) 2015-2020 BurstIQ Inc - All Rights Reserved
Unauthorized copying of this file, via any medium is strictly prohibited.
Proprietary and confidential
"""

from cmd import Cmd

from cliq_runner.runner_manager import RunnerManager
from cliq_runner.runners.dictionary_info import DictionaryInfo


class DictInterpreter(Cmd):

    def __init__(self,
                 runner: RunnerManager,
                 dict_info: DictionaryInfo):
        super().__init__()

        self._runner_manager = runner
        self._dictionary_info = dict_info

    def do_help(self, line: str):
        """
        Returns Information about the Dictionary sub-commands.
        """
        Cmd.doc_header = 'Documented Dictionary sub-commands (type "dict help <topic>"):'
        super(DictInterpreter, self).do_help(line)

    def do_list(self, line: str = None):
        """
        Prints a list of Dictionaries
        """
        print('List of Dictionaries')
        self._dictionary_info.get_dict_list(self._runner_manager)

    def do_get(self, line: str):
        """
        Gets a Dictionary
        """
        print('Printing Dictionary')
        self._dictionary_info.get_dict(line, self._runner_manager)
