"""
Copyright (c) 2015-2020 BurstIQ Inc - All Rights Reserved
Unauthorized copying of this file, via any medium is strictly prohibited.
Proprietary and confidential
"""

from cmd import Cmd

from cliq_runner.parsers.generate_parser import GenerateParser
from cliq_runner.runner_manager import RunnerManager
from cliq_runner.runners.public_private import PublicPrivate


class GenerateInterpreter(Cmd):

    def __init__(self,
                 runner: RunnerManager):
        super().__init__()

        self._runner_manager = runner

    def do_help(self, line: str):
        """
        Returns Information about the Generate sun-commands.
        """
        Cmd.doc_header = 'Documented Generate sub-commands (type "generate help <topic>"):'
        super(GenerateInterpreter, self).do_help(line)

    def do_private_id(self, line: str = None):
        """
        Generates a Private ID.
        """
        print('This is a newly generated private ID, please memorize this or write it somewhere safe,'
              ' you will not be able to recover it.')
        PublicPrivate.generate_private_id(self._runner_manager.get_info())

    def do_public_id(self, line: str = None):
        """
        This generates a public ID for the Private ID you have set or the one passed in.
        """
        print('Your Public ID')
        args = GenerateParser.generate_values(line)

        PublicPrivate.get_public_id(self._runner_manager.get_info(), args)
