"""
Copyright (c) 2015-2020 BurstIQ Inc - All Rights Reserved
Unauthorized copying of this file, via any medium is strictly prohibited.
Proprietary and confidential
"""

from cmd import Cmd

from cliq_runner.runner_manager import RunnerManager


class ProfileInterpreter(Cmd):

    def __init__(self,
                 runner: RunnerManager):
        super().__init__()

        self._runner_manager = runner

    def do_help(self, line: str):
        """
        Returns information about the Profile sub-commands
        """
        Cmd.doc_header = 'Documented Profile sub-commands (type "profile help <topic>"):'
        super(ProfileInterpreter, self).do_help(line)

    def do_list(self, line: str = None):
        """
        Prints a list of Profiles
        """
        print('List of Profile Names')
        self._runner_manager.get_profiles()

    def do_get(self, line: str):
        """
        Gets the Profile info
        """
        print('Gets the Profile info')
        self._runner_manager.get_profile(line)
