"""
Copyright (c) 2015-2020 BurstIQ Inc - All Rights Reserved
Unauthorized copying of this file, via any medium is strictly prohibited.
Proprietary and confidential
"""

import argparse

from argparse import Namespace


class MyAction(argparse.Action):
    def __call__(self, parser, namespace, values, option_string=None):
        setattr(namespace, self.dest, ' '.join(values))


class QueryParser:

    @staticmethod
    def query_parser(parser: argparse) -> argparse:
        parser.add_argument('--query',
                            '-q',
                            type=str,
                            nargs='*',
                            help='This is for the Query')
        parser.add_argument('--username',
                            '-u',
                            help='This is for the Username')
        parser.add_argument('--password',
                            '-p',
                            help='This is for the password')
        parser.add_argument('--url',
                            help='This is for the host/url')
        parser.add_argument('--client',
                            '-c',
                            help="This is for the client")
        parser.add_argument('--private_id',
                            '-pid',
                            help='This is for the private-id')
        parser.add_argument('--map_reduce',
                            '-mr',
                            help='This is the filename that holds the map reduce query info')
        parser.add_argument('--profile',
                            '-pr',
                            dest='profile',
                            help='name of profile to start',
                            required=False)
        parser.add_argument('--file',
                            '-f',
                            help='This sets the input file for tql')
        parser.add_argument('--output',
                            '-o',
                            help='This sets the output file for the results')
        parser.add_argument('--target',
                            '-t',
                            help='This sets the target either burstchain or iq')
        parser.add_argument('--asset_type',
                            '-at',
                            help='This is for selecting asset type')
        return parser

    @staticmethod
    def get_query_values(line: str) -> Namespace:
        parser = argparse.ArgumentParser()
        parser.add_argument('collection',
                            help='This is the collection/chain that will be queried.')
        args = QueryParser.query_parser(parser).parse_args(line.split())
        if args.query is not None:
            args.query = ' '.join(args.query)
            args.query = args.query.strip('\"')
        return args
