"""
Copyright (c) 2015-2020 BurstIQ Inc - All Rights Reserved
Unauthorized copying of this file, via any medium is strictly prohibited.
Proprietary and confidential
"""

import sys

from setuptools import setup, find_packages


def forbid_publish():
    argv = sys.argv
    blacklist = ['register', 'upload']

    for command in blacklist:
        if command in argv:
            values = {'command': command}
            print('Command "%(command)s" has been blacklisted, exiting...' %
                  values)
            sys.exit(2)


forbid_publish()

setup(
    name='cliq',
    version='2.0.0',
    description='CLI and Interactive tool for working with BurstServer; CLIQ (Command Line IQ)',
    author_email='Scott Campana <scott.campana@burstiq.com>',
    author='Scott Campana',

    license='Apache License Version 2',

    url='http://www.burstiq.com',
    download_url='',

    entry_points={
        'console_scripts': [
            'cliq=cliq_runner.main:main'
        ]
    },

    install_requires=['argparse',
                      'requests',
                      'PyYAML',
                      'mock'],

    packages=['cliq_runner', 'cliq_runner.interpreters', 'cliq_runner.info', 'cliq_runner.runners',
              'cliq_runner.parsers'],

    package_data={},

    test_suite='nose2.collector.collector',
    tests_require=['nose2>=0.8.0']
)
